uses grafx2,gx_glob,crt,pnglib,mouselib,timebase,stream32,objects,jlib,gx_fx;
const
  flarepos : array[1..16] of integer=(-1110,-666,0,1087,1221,1309,1776,2197,
                                      2819,3130,3220,3263,3663,3707,4440,5125);
  flareput : array[1..16] of byte=(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
var
  flare     : array[1..16] of timage;
  screen    : tgxscreen;
  vscreen   : tgxmem;
  vimage    : timage;
  i         : integer;
  x,y       : integer;
  xpos,ypos : word;
  mouse     : tmouse;
  timer     : tztimer;
  imgcount  : longint;
  lastcount : comp;
  fps       : single;
  stream    : tfilestream32;
  bgimage   : timage;
  gx2       : timage;

begin
  globalinitmouse(0);
  screen.init(640,480,clhitrueno24,mdauto);
  openimage(vimage,screen.maxx+1,screen.maxy+1,screen.mode.bpp,0,imdefault);

  for i := 1 to 16 do
  begin
    stream.init('images\flare-'+inttostr(i)+'.png',stopenread);
    check4fail(loadpng(stream,flare[i],screen.mode.bpp,lddither));
  end;

  stream.init('images\sky.jpg',stopenread);
  check4fail(loadjpeg(stream,bgimage,screen.mode.bpp,lddither));

  stream.init('images\gx2sm2.png',stopenread);
  check4fail(loadpng(stream,gx2,screen.mode.bpp,ldalpha));

  vscreen.init(vimage);
  mouse.init(screen,0);
  mouse.hide;
  timer.init;
  imgcount := 0;
  lastcount := timer.count;
  timer.start;
  mouse.setwindow(0,0,screen.mode.maxx,315);

  vscreen.setfontattributes(textdefault,textdefault,textadd);
  repeat
    xpos := mouse.pos.x;
    ypos := mouse.pos.y;
{    vscreen.draw(0,0,bgimage,drdefault);}
    vscreen.draw(0,0,bgimage,drdefault);
    vscreen.fillrect(0,0,vscreen.mode.maxx,vscreen.mode.maxy,vscreen.rgb(0,round(((ypos)/screen.maxy)*64),
    round(((ypos)/screen.maxy)*64)),fillsub);
{    brightness_image(bgimage,vimage,255-round(((ypos)/screen.maxy)*150));}
    for i := 1 to 16 do if flareput[i] = 1 then
    begin
      x := (screen.centerx+((screen.centerx-xpos)*(flarepos[i]-2280) div 2280))-flare[i].sizex shr 1;
      y := (screen.centery+((screen.centery-ypos)*(flarepos[i]-2280) div 2280))-flare[i].sizey shr 1;
      vscreen.draw(x,y,flare[i],dradd);
    end;
{    vscreen.fillrect(0,0,vscreen.mode.maxx,vscreen.mode.maxy,vscreen.rgb(round(((ypos)/screen.maxy)*64),0,0),filladd);}
    if (timer.lap >= 4/timer.resolution) then
    begin
      timer.stop;
      timer.start;
      fps := imgcount/4;
      imgcount := 0;
    end;
    vscreen.write(10,10,flttostr(fps,4,2)+' fps',vscreen.gray(127));
    vscreen.draw(0,vscreen.maxy-gx2.sizey,gx2,drdefault);
    screen.draw(0,0,vimage,drdefault);
    inc(imgcount);
  until keypressed;
  while keypressed do readkey;

  timer.done;
  vscreen.close;
  closeimage(vimage);
  closeimage(gx2);
  mouse.done;
  screen.close;
  globaldonemouse;
end.